def mossa_valida(i, j):
  """
  Restituisce True solo se le coordinate (i,j)
  rappresentano una posizione valida di gioco
  (sono all'interno della tavola e in una
  posizione libera )
  """
  if i < 0 or i > 2:
    return False
  if j < 0 or j > 2:
    return False
  if tavola[i][j] != 0:
    return False
  return True


def stampa_tavola():
  """
  Stampa la tavola di gioco
  """
  for i in range(0,3):
    for j in range(0,3):
      # end="" è un argomento aggiutivo che dice
      # cosa stampare alla fine della stringa. Di
      # default è "\n", ovvero il ritorno a capo
      if tavola[i][j] == 0:
        print("_ ", end="")
      elif tavola[i][j] == 1:
        print("X ", end="")
      else:
        print("O ", end="")
    print()


def vittoria(giocatore):
  """
  Restituisce True solo se il il giocatore indicato
  (1 o 2) ha posizionato tre simboli in fila
  """
  for i in range(0,3):
    # Verticale
    if tavola[i][0] == giocatore and tavola[i][1] == giocatore and tavola[i][2] == giocatore:
      return True
    # Orizzontale
    if tavola[0][i] == giocatore and tavola[1][i] == giocatore and tavola[2][i] == giocatore:
      return True
  # diagonali
  if tavola[0][0] == giocatore and tavola[1][1] == giocatore and tavola[2][2] == giocatore:
    return True
  if tavola[0][2] == giocatore and tavola[1][1] == giocatore and tavola[2][0] == giocatore:
    return True
  return False


def piena():
  """
  Ritorna vero se non ci sono più posizioni libere
  all'interno della tabella.
  """
  for i in range(0,3):
    for j in range(0,3):
      if tavola[i][j] == 0:
        return False
  return True

tavola = [[0, 0, 0],
          [0, 0, 0],
          [0, 0, 0]]

giocatore_attuale = 2
# Continuiamo il ciclo finché non abbiamo un
# vincitore o la tabella non è piena
while not vittoria(giocatore_attuale) and not piena():
  # All'inizio di ogni turno cambiamo
  # il giocatore che deve inserire la mossa
  if giocatore_attuale == 2:
    giocatore_attuale = 1
  else:
    giocatore_attuale = 2
  print("Giocatore " + str(giocatore_attuale) + " è il tuo turno")
  stampa_tavola()
  valida = False # inizialmente non abbiamo una mossa valida
  # finché non inseriamo una mossa valida continuiamo
  # a richiderla e non usciamo dal ciclo while
  while not valida:
    print("Inserisci la tua mossa:")
    i = int(input())
    j = int(input())
    valida = mossa_valida(i,j)
  tavola[i][j] = giocatore_attuale
stampa_tavola()
if vittoria(giocatore_attuale):
  print("Il giocatore " + str(giocatore_attuale) + str(" ha vinto!"))
else:
  print("Pareggio")
